config/routes.rb
# encoding: utf-8
class CourseConstraint
  def matches?(request)
    params = request.path_parameters
    tmp_course = Course.find(params[:id])
    return false if params[:course] != tmp_course.course.parameterize('_')
    true
  end  
end

class MediaConstraint
  def matches?(request)
    obj = request.fullpath.include?('media') ? Media : Audio
    params = request.path_parameters
    tmp = obj.find(params[:id])
    return false if params[:end_date] != tmp.end_date
    true
  end  
end
  
Rails.application.routes.draw do
  root 'welcome#index'
  get 'welcome/index'
  get '/ruby-version' => 'application#ruby_version'
  resources :media do
   collection do
     get 'search', to: 'media#search'
   end 
  end
  resources :audios do
   collection do
     get 'search', to: 'audios#search'
   end 
  end  
  resources :courses do
   collection do
     post 'add_to_course', to: 'courses#add_to_course'
     get 'search', to: 'courses#search'
     get 'clone_course', to: 'courses#clone_course'
     get 'send_email', to: 'courses#send_email'
     get 'archive', to: 'courses#archive'
     get 'archive_search', to: 'courses#archive_search'
     get 'lookup', to: 'courses#lookup'
     get 'unarchive', to: 'courses#unarchive'
     get 'sort', to: 'courses#sort'
   end
  end
  resources :analytics
  resources :licensed_analytics
    
  get 'media/:id/:ds', :to => 'file#show', :constraints => { :ds => /[^\/]+/ }, :as => 'file'  
  get 'courses/:id/:quarter/:year/:course', :to => 'courses#show', constraints: CourseConstraint.new, :as => :course_report
  get 'media/:id/:end_date/:file_name', :to => 'media#view', constraints: MediaConstraint.new, :as => 'video_view'
  get 'audios/:id/:end_date/:file_name', :to => 'audios#view', constraints: MediaConstraint.new, :as => 'audio_view'

  get '/auth/shibboleth', as: :shibboleth
  get '/auth/developer', to: 'users/sessions#developer', as: :developer
  match '/auth/shibboleth/callback' => 'users/sessions#shibboleth', as: :callback, via: [:get, :post]
  get '/users/sign_in', :to => 'users/sessions#new', :as => :new_user_session
  get '/users/sign_out', :to => 'users/sessions#destroy', :as => :destroy_user_session

  # Log out
  get 'logout', :to => 'welcome#logout', as: :logout

  match '*a', :to => 'errors#routing', via: [:get]
end

app/models/course.rb
#
# @author Vivian <tchu@ucsd.edu>
#
class Course < ActiveRecord::Base
  has_many :reports, dependent: :delete_all
  has_many :media, through: :reports
  has_many :audioreports, dependent: :delete_all
  has_many :audios, through: :audioreports

  validates :quarter, presence: true
  validates :year, presence: true, length: { maximum: 4 },
                   format: { with: /\A\d{4}\z/, message: 'must be in number format' }
  validates :course, presence: true
  validates :instructor, presence: true

  ##
  # Enables copying
  #
  amoeba do
    enable
    clone [:media]
    clone [:reports]
    clone [:audios]
    clone [:audioreports]
  end
end

app/models/media.rb
#
# @author Vivian <tchu@ucsd.edu>
#
class Media < ActiveRecord::Base
  has_many :reports, dependent: :delete_all
  has_many :courses, through: :reports
  validates :title, presence: true
  validates :file_name, presence: true, format: { with: /\A.+(\.mp4)\z/, message: 'must be in mp4' }

  ##
  # Enables copying
  #
  amoeba do
    enable
  end
end

app/controllers/media_controller.rb
#
# @author Vivian <tchu@ucsd.edu>
#
class MediaController < ApplicationController
  include Dmr::ControllerHelper
  before_action :authorize, only: [:index, :show, :edit, :update, :new, :destroy,
                                   :search]
  before_action :set_media, only: [:show, :edit, :update, :destroy, :view]
  ##
  # Handles GET index request to display the last 10 Media from database
  #
  # @return [String] the resulting webpage of the last 10 Media objects
  #
  def index
    @media = Media.order('created_at DESC').limit(10)
  end

  ##
  # Handles GET show request to display the details of a single Media object
  #
  # @return [String] the resulting webpage of a single object
  #
  def show
    render layout: false
  end

  ##
  # Handles GET show request to display the details of a single Media object
  # GET /view/1/filename
  #
  # @return [String] the resulting webpage of a single object
  #
  def view
    render layout: false
  end

  ##
  # Handles GET new request to a new Media object
  #
  # @return [String] for creating a new Media
  #
  def new
    @media = Media.new
  end

  ##
  # Handles POST create a Media object
  #
  # @note if successful
  # @return [String] - redirect to the resulting webpage of all Media objects
  # @note if failure
  # @return [String] the new Media form
  #
  def create
    @media = Media.new(media_params)
    if @media.save
      redirect_to edit_medium_path(@media), notice: 'Video was successfully created.'
    else
      render :new
    end
  end

  ##
  # Handles GET edit a Media object
  #
  # @return [String] the resulting webpage with the Media object
  #
  def edit; end

  ##
  # Handles PUT update a Media object
  #
  # @note if successful
  # @return [String] - redirect to the resulting webpage
  # @note if failure
  # @return [String] the edit Media form
  #
  def update
    if @media.update_attributes(media_params)
      redirect_to edit_medium_path(@media), notice: 'Video successfully updated.'
    else
      render :edit
    end
  end

  ##
  # Handles GET delete a Media object
  #
  # @return [String] - redirect to the Media index page
  #
  def destroy
    @media.destroy
    redirect_to media_path, notice: 'Video was successfully destroyed.'
  end

  ##
  # Handles GET search for Media object
  #
  def search
    return unless params[:search]
    if params[:search].blank?
      redirect_to root_path, alert: 'No text is inputted.'
    elsif params[:search].present?
      perform_search
      create_search_session
    end
  end

  private

  ##
  # Specify which parameters are allowed into Media controller actions to
  # prevent wrongful mass assignment.
  #
  # @!visibility private
  #
  def media_params
    params.require(:media).permit(:title, :director, :call_number, :year,
                                  :file_name, :end_date, course_ids: [])
  end

  # Use callbacks to share common setup or constraints between actions.
  def set_media
    @media = Media.find(params[:id])
  end

  def search_course_option?
    params[:search_option] == 'courses'
  end

  def search_audio_option?
    params[:search_option] == 'audio'
  end

  def create_search_session
    session[:search] = params[:search]
    session[:search_option] = params[:search_option] if params[:search_option]
  end

  def perform_search
    if search_course_option?
      redirect_to controller: 'courses', action: 'search',
                  search: params[:search], search_option: params[:search_option]
    elsif search_audio_option?
      redirect_to controller: 'audios', action: 'search',
                  search: params[:search], search_option: params[:search_option]
    else
      @media = full_search(params[:search], Media).order(:title).page(params[:page]).per(20)
      @search_count = @media.count
    end
  end
end

app/helpers/media_helper.rb
#
# @author Vivian <tchu@ucsd.edu>
#
require 'base64'
require 'pathname'

APP_ROOT = Pathname.new File.expand_path('../../../', __FILE__)
#
# This module supports the function in Media controller
#
module MediaHelper
  def grab_secure_token_url(filename, base_url)
    return unless filename
    token_end_time = wowza_token_end_time
    token_hash = wowza_token_hash(token_end_time, filename, base_url)
    "#{Rails.configuration.secure_token_name}endtime=#{token_end_time}&#{Rails.configuration.secure_token_name}hash=#{token_hash}".html_safe
  end

  def wowza_token_hash(end_time, filename, base_url)
    token_params = []
    token_params << Rails.configuration.secure_token_secret
    token_params << "#{Rails.configuration.secure_token_name}endtime=#{end_time}"
    token_params = token_params.sort
    stream = base_url.sub(%r{.*?\/}, '')
    hash_in = "#{stream}#{filename}?#{token_params.join('&')}"
    hash_out = Digest::SHA2.new(256).digest(hash_in.to_s)
    base64_encode(hash_out).gsub('+/', '-_').to_s
  end

  def wowza_token_end_time
    Time.zone = 'America/Los_Angeles'
    Time.now.to_i + 48.hours
  end

  def get_file_url(file_name, file_ext)
    temp_file = file_name.gsub('.mp4', file_ext)
    return nil unless File.exist?("#{Rails.configuration.smil_filepath}#{temp_file}")
    if file_ext.include?('smil')
      "#{Rails.configuration.wowza_baseurl_smil}#{temp_file}"
    elsif file_ext.include?('srt')
      "#{Rails.configuration.wowza_baseurl_smil.gsub('smil:', '')}#{temp_file}"
    end
  end

  def get_wowza_url(file_name, file_ext)
    get_file_url(file_name, file_ext) || "#{Rails.configuration.wowza_baseurl}#{file_name}"
  end
end

app/views/media/_media_form.html.erb
<div class="required">
  <%= f.text_field :title, label: "Title"%>
</div>
<%= f.text_field :director, label: "Director" %>
<%= f.text_field :call_number, label: "Call Number" %>
<%= f.text_field :year, label: "Year" %>
<div class="required">  
<%= f.text_field :file_name, label: "File Name" %>
</div>
<div class="form-group">
  <% e_date = @media.end_date ? @media.end_date : ""%>
  <label class="control-label" for="media_end_date">End Date</label>
  <input type="text" name="media[end_date]" id="media_end_date" value="<%= e_date%>" size="20" placeholder="YYYY-MM-DD" class="enddatepicker form-control" data-date-format="yyyy-mm-dd"/>
</div> 

app/views/media/_media_show.html.erb
<h3>Video Record Core Data</h3>
<form class="form-horizontal">
  <div class="form-group">
    <label class="col-sm-2 control-label">Title:</label>
    <div class="col-sm-10">
      <p class="form-control-static"><%= obj.title %></p>
    </div>
    <label class="col-sm-2 control-label">Director:</label>
    <div class="col-sm-10">
      <p class="form-control-static"><%= obj.director %></p>
    </div>
    <label class="col-sm-2 control-label">Call Number:</label>
    <div class="col-sm-10">
      <p class="form-control-static"><%= obj.call_number %></p>
    </div>
    <label class="col-sm-2 control-label">Year:</label>
    <div class="col-sm-10">
      <p class="form-control-static"><%= obj.year %></p>
    </div>
    <label class="col-sm-2 control-label">File Name:</label>
    <div class="col-sm-10">
      <p class="form-control-static"><%= obj.file_name %></p>
    </div>                                   
  </div>
</form>

app/views/media/_search_result.html.erb
<%= bootstrap_form_for :course, url: add_to_course_courses_path do |f| %>
  <div class="container">
    <div class="row">
      <div class="panel panel-default">
        <table class="table table-striped table-hover table-bordered">
          <thead>
            <tr>
              <th class="col-xs-1" scope="col"><%= label_tag 'check_all', 'check_all', class: "hide-label"%><%= check_box_tag 'check_all',false%></th>
              <th class="col-xs-1" scope="col">Thumbnail</th>
              <th class="col-xs-4" scope="col">Title</th>
              <th class="col-xs-2" scope="col">Director</th>
              <th class="col-xs-2" scope="col">Call Number</th>
              <th class="col-xs-1" scope="col">Year</th>
              <th class="col-xs-1" scope="col">File Name</th>
              <th class="col-xs-2" scope="col" style="min-width:100px;">End Date</th>
            </tr>
          </thead>
          <tbody>
            <% obj.each do |m| %>
              <% thumbnailURL = "#{Rails.configuration.file_path}#{m.file_name.gsub('.mp4','.jpg')}"%>
              <tr>
                <td><fieldset><legend class="hide-label">Type</legend><%= label_tag "media_ids_#{m.id}", 'media_ids[]', class: "hide-label"%>
                <%= check_box_tag 'media_ids[]', m.id, false, id: "media_ids_#{m.id}"%></fieldset></td>
                <td><%=image_tag "#{thumbnailURL}", :alt => '', :class => 'search-thumbnail' %></td>          
                <td><%= link_to "#{m.title}", edit_medium_path(m.id), 'data-no-turbolink' => true %></td>
                <td><%= m.director %></td>
                <td><%= m.call_number %></td>
                <td><%= m.year %></td>
                <td><%= m.file_name %></td>
                <td><%= m.end_date %></td>
              </tr>
            <% end %>
          <tbody>
        </table>
      </div>
    </div>
  </div>
  <% if @search_count && @search_count > 0%>
    <%= render :partial => 'shared/display_bottom_paginate' , :locals => {:obj => obj}%>
  <% end %>
  <div class="text-center">
    <%= f.primary "Add to Course List"%>    
    <%= link_to "Create New Video Record", new_medium_path, class: "btn btn-primary"%>
    <%= f.primary "Delete Selected Records", data: { confirm: 'Are you sure?' }%>
  </div>  
<% end %>  

app/views/media/_video_viewer.html.erb
<div id="tdr_content_content" style="width:100%;max-width:100%;">
<h3><%= obj.title%></h3>
<%
  if obj
    wowzaURL = get_wowza_url(obj.file_name, '.smil')
    srtURL = get_file_url(obj.file_name, '.srt')    
  end
%>

<% if wowzaURL %>

  <video controls="controls" id="dar-video">Loading the player...</video>

	<script type="text/javascript">
		jwplayer("dar-video").setup({
			playlist:
			[{
				sources:
				[
					{file: "https://<%=wowzaURL%>/playlist.m3u8"}
				]
			}],
			width: "100%",
			height: "100%",
			aspectratio: "16:9",
			rtmp: {bufferlength: 3},
			analytics: {enabled: false}
		});
	</script>

<% end %>
</div>

app/views/media/edit.html.erb
<div class="container">
  <div class="row">
    <div class="col-sm-10">
	  <div class="col-xs-9 col-sm-9">
	    <h3>Video Record Core Data</h3>
	    <%= render :partial => 'shared/error_messages' , :locals => {:obj => @media}%>
	    <p class="required">* Required field </p>
	  
	    <%= bootstrap_form_for @media, :required=>true do |f| %>
	      <%= render :partial => 'media_form' , :locals => {:f => f}%>
	      <%= f.primary "Save"%>
	      <%= link_to "Play File", medium_path(@media), class: "btn btn-primary", 'data-no-turbolink' => true , :onclick=>"window.open(this.href,'video_player', 'height=600, width=600');return false;" %>
	      <% if @media.end_date && !@media.end_date.blank? %>
	        <%#= link_to "URL", video_view_path(@media), class: "btn btn-primary", 'data-no-turbolink' => true , :onclick=>"window.open(this.href,'video_player', 'height=700, width=1000');return false;" %>
            <%= link_to "URL", video_view_path(@media), class: "btn btn-primary", 'data-no-turbolink' => true, :onclick=>"alert(this.href);return false;" %>
          <% end %>
	      <%= link_to "Delete", @media, method: :delete, data: { confirm: 'Are you sure?' }, class: "btn btn-primary"%>
	      <%= link_to "Add to Course List", add_to_course_courses_path(:course, :media_ids => ["#{@media.id}"]), :method=> :post, class: "btn btn-primary"%>	     
	      <%= link_to "Return to Search Results", search_media_path(:search => session[:search]), class: "btn btn-primary"%>
	    <%end%>	    	      
	  </div>
      <%= render :partial => 'shared/thumbnail' , :locals => {:obj => @media}%>
    </div>
  </div>
</div>

app/views/media/index.html.erb
<div class="text-center"><h3>Listing Video</h3></div>
<%= render :partial => 'search_result' , :locals => {:obj => @media}%> 

app/views/media/new.html.erb
<div class="container">
  <div class="row">
	<div class="object-panel">
	  <h3>New Video Record Core Data</h3>
	  <%= render :partial => 'shared/error_messages' , :locals => {:obj => @media}%>
	  <p class="required">* Required field </p>
	
	  <%= bootstrap_form_for :media, url: media_path do |f| %>
        <%= render :partial => 'media_form' , :locals => {:f => f}%>
        <div class="center-block">
          <%= f.primary "Save"%>
	      <input class="btn btn-primary" type="reset" value="Cancel"/>
	      <%= link_to "Return to Search Results", media_path, class: "btn btn-primary"%>
	    </div>
	  <% end %>
	</div>
  </div>
</div>	  

app/views/media/search.html.erb
<% if @search_count && @search_count > 0%>
  <%= render :partial => 'shared/display_paginate' , :locals => {:obj => @media}%>
  <%= render :partial => 'search_result' , :locals => {:obj => @media}%> 
<% elsif @search_count && @search_count == 0%>
  <div class="text-center">There were no results for the search: "<%= params[:search]%>"</div>
<% end %>

app/views/media/show.html.erb
<!DOCTYPE html>
<html lang="en">
<%= render :partial => 'shared/head'%>
<body>
<div class="container-fluid">
  <%= render :partial => 'video_viewer' , :locals => {:obj => @media}%>  
</div>
</body>
</html>

app/views/media/view.html.erb
<!DOCTYPE html>
<html lang="en">
<%= render :partial => 'shared/report_header'%>
<body>
  <%= render :partial => 'shared/report_menu'%>
  <div id="tdr_content" class="tdr_fonts" style="width:80%;margin-left:auto;margin-right:auto;">  
    
	<%= render :partial => 'video_viewer' , :locals => {:obj => @media}%>          
  <%= render :partial => 'shared/report_footer'%>
  
</body>
</html>